<template>
  <q-layout view="hhh lpr fff">
    <q-no-ssr>
      <q-header
        reveal
        bordered
        class="q-px-md q-py-md bg-dark"
        height-hint="98"
      >
        <q-toolbar>
          <q-toolbar-title>Game Studio</q-toolbar-title>
          <router-link to="/admin/dashboard" v-if="user.id">
            <q-btn rounded class="bg-orange text-dark">My Dashboard</q-btn>
          </router-link>
          <router-link to="/login" v-else>
            <q-btn rounded class="bg-orange text-dark">Login/Daftar</q-btn>
          </router-link>
        </q-toolbar>
        <q-toolbar>
          <q-tabs class="scroll">
            <q-route-tab to="/" label="Home" />
            <q-route-tab to="/game" label="Games" />
            <q-route-tab to="/blog" label="Blogs" />
            <q-route-tab to="/contact" label="Contact" />
          </q-tabs>
        </q-toolbar>
      </q-header>
    </q-no-ssr>

    <q-page-container>
      <router-view />
    </q-page-container>

    <q-footer bordered class="bg-dark text-grey">
      <q-no-ssr>
        <div class="row bg-grey-9 q-pa-lg">
          <div class="col-md-4 col-xs-12 q-pa-sm">
            <h5>Game Studio</h5>
            <p>Memberikan pelayanan terbaik kepada para gamers budiman</p>
          </div>
          <div class="col-md-4 col-xs-12 q-pa-sm">
            <q-card class="bg-dark">
              <q-card-section>
                <div class="text-h6 q-pa-sm">Game Terbaru</div>
                <div
                  class="row q-pa-sm"
                  v-for="item in news.games"
                  :key="item.slug"
                >
                  <div class="col-3">
                    <router-link :to="'/game/' + item.slug">
                      <image-view
                        :src="item.thumbnail"
                        :alt="placeholderImages.game"
                      />
                    </router-link>
                  </div>
                  <div class="col q-px-sm">
                    <div class="column">
                      <div class="col text-orange">{{ item.created_at }}</div>
                      <router-link :to="'/game/' + item.slug">
                        <div class="col text-white">{{ item.title }}</div>
                      </router-link>
                      <div class="col">{{ item.author }}</div>
                    </div>
                  </div>
                </div>
              </q-card-section>
            </q-card>
          </div>
          <div class="col-md-4 col-xs-12 q-pa-sm">
            <q-card class="bg-dark">
              <q-card-section>
                <div class="text-h6 q-pa-sm">Postingan Terbaru</div>
                <div
                  class="row q-pa-sm"
                  v-for="item in news.blogs"
                  :key="item.title"
                >
                  <div class="col-3">
                    <router-link :to="'/blog/' + item.slug">
                      <image-view
                        :src="item.thumbnail"
                        :alt="placeholderImages.post"
                      />
                    </router-link>
                  </div>
                  <div class="col q-px-sm">
                    <div class="column">
                      <div class="col text-orange">{{ item.created_at }}</div>
                      <router-link :to="'/blog/' + item.slug">
                        <div class="col text-white">{{ item.title }}</div>
                      </router-link>
                      <div class="col">{{ item.author }}</div>
                    </div>
                  </div>
                </div>
              </q-card-section>
            </q-card>
          </div>
        </div>
        <q-toolbar class="q-pa-md">
          <q-toolbar-title>Imajora News</q-toolbar-title>
        </q-toolbar>
        <div class="q-pa-md">&copy; 2022 All Right Reserved</div>
      </q-no-ssr>
    </q-footer>
  </q-layout>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { useAdminStore } from 'stores/admin';
import { useLatestNewsStore } from 'stores/latest-news';
import { LocalStorage } from 'quasar';
import { localAPI } from 'src/boot/axios';
import { placeholderImages } from 'src/boot/placeholder';
import ImageView from 'src/components/ImageView.vue';

export default defineComponent({
  name: 'MainLayout',

  components: {
    ImageView,
  },
  setup() {
    const user = useAdminStore();
    const news = useLatestNewsStore();
    news.fetchItems();
    const token = LocalStorage.getItem('auth_token');
    if (token) {
      localAPI
        .post(
          '/auth/login',
          {},
          {
            headers: {
              auth_token: token,
            },
          }
        )
        .then((res) => {
          if (res.data.meta?.status === 'success') {
            const data = res.data.payload?.user;
            user.id = data?.id;
            user.username = data?.username;
            user.role = data?.role;
          } else {
            LocalStorage.remove('auth_token');
          }
        })
        .catch((err) => {
          LocalStorage.remove('auth_token');
          console.error(err);
        });
    }
    return {
      user,
      news,
      placeholderImages,
    };
  },
});
</script>
